import 'package:amazon_cognito_identity_dart_2/cognito.dart';

class User {
  String? email;
  String? name;
  String? password;
  bool confirmed = false;
  bool hasAccess = false;

  User({this.email, this.name});

  /// Decode user from Cognito User Attributes
  factory User.fromUserAttributes(List<CognitoUserAttribute> attributes) {
    final user = User();
    attributes.forEach((attribute) {
      if (attribute.getName() == 'email') {
        user.email = attribute.getValue();
      } else if (attribute.getName() == 'name') {
        user.name = attribute.getValue();
      } else if (attribute.getName() != null && attribute.getName()!.toLowerCase().contains('verified')) {
        if (attribute.getValue() != null && attribute.getValue()!.toLowerCase() == 'true') {
          user.confirmed = true;
        }
      }
    });
    return user;
  }
}
